<template>
  <LayoutMain>
    <section>
      <!--TÍTULO SECCIÓN-->
      <b-container>
        <b-row align-h="center">
          <b-col cols="12">
            <TitleShape title="Mi perfil" />
          </b-col>
        </b-row>
      </b-container>
      <!--SI ENTRO EN MODO EDITAR CARGO EL FORMULARIO-->
      <div class="color-wrapper" v-if="editMode">
        <b-container v-if="!this.isUserLoading">
          <b-form-row class="justify-content-center text-center">
            <b-col cols="6">
              <b-form @submit="onSubmit" @reset="onReset" enctype="multipart/form-data">
                <b-form-group label-for="avatar">
                  <ImageProfile  :src="avatarSrc " size="6rem" />
                </b-form-group>
                <!-- Buscador de imágenes. Aquí llamo al evento @change para obtener el archivo seleccionado-->
                <b-form-group label-for="image">
                  <b-form-file v-model="avatarFile" @change="getAvatar" class="buscador" ></b-form-file>
                </b-form-group>

                <b-form-group>
                  <b-form-input v-model="profileForm.name" placeholder="Nombre de usuario"></b-form-input>
                </b-form-group>
                <b-alert :show="isProfileLoaded=='error'">Nombre de usuario no válido</b-alert>
                <b-form-group>
                  <b-form-input v-model="profileForm.email" type="email" placeholder="Correo electrónico"></b-form-input>
                </b-form-group>

                <b-container>
                  <b-row>
                    <b-col cols="6">
                      <b-button size="lg" v-on:click="cancelEdit" variant="secondary" >Cancelar</b-button>
                    </b-col>
                    <b-col cols="6">
                      <b-button size="lg" type="submit" variant="primary">Guardar</b-button>
                    </b-col>
                  </b-row>
                  </b-container>
              </b-form>
            </b-col>
          </b-form-row>
        </b-container>
        <b-container v-else>
          Cargando
        </b-container>
      </div>
      <!--POR DEFECTO MUESTRO LOS DATOS DEL USUARIO-->  
      <div class="color-wrapper" v-else>
        <b-container>
          <b-row  align-h="center">
            <b-col cols="6" class="text-center">
              <ImageProfile  :src="avatarSrc" size="6rem" />
              <p>{{ profile.name }}</p>
              <p>{{ profile.email }}</p>
          <b-container>
          <b-row  align-h="center">
            <b-col cols="6" class="text-left"></b-col>
            <b-col cols="6" class="text-right">
              <b-button size="lg" v-on:click="editForm" variant="primary">Editar</b-button>
            </b-col>
          </b-row>
          </b-container>
          </b-col>
          </b-row>
        </b-container>
        
      </div>
    </section>
    <b-container class="mt-3">
      <b-row>
          <b-col cols="6">
            <b-button size="lg" v-on:click="$router.go(-1)" variant="secondary" >Volver</b-button>
          </b-col>
      </b-row>
    </b-container>
  </LayoutMain>
</template>

<script>
// @ is an alias to /src
import LayoutMain from "@/components/layouts/Main.vue";
import TitleShape from "@/components/TitleShape.vue";
import ButtonEdit from "@/components/ButtonEdit.vue";
import ImageProfile from "@/components/ImageProfile.vue";
import { mapState, mapGetters } from "vuex";

export default {
  name: "home",
  components: {
    LayoutMain,
    TitleShape,
    ButtonEdit,
    ImageProfile
  },
  //En 'computed' es donde se almacenan los datos que pueden sufrir cambios.
  computed: {
    //A mapState le tengo que pasar el nombre del módulo, en este caso 'user' y la propiedad con los datos que quiero tener a mi disposición
    //profile el la propiedad que me dispone de los datos del usaurio X.
    ...mapGetters("user", {isUserLoading: "isLoading"}),
    ...mapState("auth", ["user"]),
    avatarSrc(){
      if(!this.editMode){
        console.debug(this.profile.image)
        //Modo mostrar datos
        if(this.profile && this.profile.image){
          return this.profile.image;
        }else{
          return require('@/assets/img/default.png');
        }
      }else{
        //Modo editar
        if(this.miniatureAvatar){
          return this.miniatureAvatar;
        }if(this.profile && this.profile.image){
          return this.profile.image;
        }else{
          return require('@/assets/img/default.png');
        }
      }
    }
  },
  data() {
    return {
      editMode: false,
      profile: {},
      avatar: '',
      avatarFile: null,
      miniatureAvatar: '',
      storageUrl: process.env.VUE_APP_ROOT_STORAGE,
      profileForm: {}

    };
  },
  // 'mounted' es un 'hook' que se llama en un momento determinado del ciclo de vida de la instancia.
  // Ésta función es llamada justo después de que se monta la instancia.
  // Todos los hooks del ciclo de vida se llaman en el contexto this apuntando a la instancia de Vue que lo invoca.
  // Por lo tanto, una vez montada la instancia quiero que se despache la acción "user/profile"
  mounted() {    
    this.$store.dispatch('user/show', this.user.id).then(result => {
      // Trabajar con el estado
      this.profile = {...result.data}
      this.profileForm = {...result.data};
      }).catch(
        (error) => {
          alert(error)
        }
      )
  },
  methods: {
    /*Modo editar*/
    editForm(){
      this.editMode = true
    },
    /*Modo visualización de datos*/
    cancelEdit(){
      this.editMode = false
      this.miniatureAvatar = null
    },
    onSubmit(evt) {
      evt.preventDefault();
      //Preparo un new formData.
      let formData = new FormData();
      //Agrego mediante "append" los valores del formulario al nuevo formData
      if(this.avatarFile){
        formData.append('image', this.avatarFile);
      }
      formData.append('name', this.profileForm.name);
      
      this.$store.dispatch('user/update', {user: this.user.id, formData} ).then(result => {
        this.profile = {...result.data}
        this.profileForm = {...result.data};
        //Con un toast muestro un mensaje para indicar que se han guardado los cambios
        this.$bvToast.toast(`Guardado`, {
            title: 'Actualización de datos',
            autoHideDelay: 5000,
            variant: 'success'
          })
        //Para volver a mostrar los datos del usuario pongo a 'false' el modo editar
        this.editMode = false      
      }).catch(
        (error) => {
          //      
          Object.entries(error.errors).forEach(([key, msgs]) => {
            msgs.forEach((msg) => {
              this.$root.$bvToast.toast(msg, {
                title: 'Error',
                autoHideDelay: 5000,
                variant: 'danger'
              })
            })
          });
        }
      ) 
    },
    onReset(evt) {
      evt.preventDefault();
      // Reset our form values
      this.profileForm =  {...this.profile};

      // Trick to reset/clear native browser form validation state
      this.$nextTick(() => {});
    },
    //Función para obtener el archivo seleccionado. Le paso 'e' que hace referencia al evento
    getAvatar(e){
      //Guardo el archivo
      let file = e.target.files[0];
      //Asigno a la propiedad 'avatar' del data el archivo.
      if (file) { 
        this.avatar = file;
        this.loadAvatar(file);
      } else {
        this.miniatureAvatar = null;
        this.avatar = '';
      }
    },
    //Función para cargar la imagen seleccionada para presentarla
    loadAvatar(file){
      //Preparo una variable con la clase FileReader. Esto me permitirá obtener la ruta del archivo así como otros parámetros 
      let reader = new FileReader();
      //La 'e' hace referencia al archivo 'file'
      reader.onload = (e) => {
        this.miniatureAvatar = e.target.result;
      }
      //De esta forma puedo emplear el archivo en el formulario.
      reader.readAsDataURL(file);
    }
  }
};
</script>


